#include "combinator.hh"
#include "operator.hh"

//#include <stdio.h>

void Combinator::calculateherz()
{
    register unsigned freqnum = freqlo + (freqhi*256);
    hz = freqnum * 49716 / (1 << (20 - octave));
    
    /*
        freqnum = hz * 2^(20 - octave) / 49716 Hz
        
    So, 
    
        hz = freqnum * 49716 Hz / 2^(20 - octave)
    
    */
    
    /*
    printf("%p Freqnum %X:%02X, octave %u, %u Hz\n",
           (void*)this,
           freqhi,freqlo, octave, hz);
    */
}

void Combinator::WriteA0(unsigned char value)
{
    freqlo = value;
    calculateherz();
}

void Combinator::WriteB0(unsigned char value)
{
    if(!enabled)angle = 0.0;
    freqhi = value & 3;
    octave = (value >> 2) & 7;
    enabled = value & 0x20;
    calculateherz();
}

void Combinator::WriteC0(unsigned char value)
{
    additive     = value & 1;
    feedbacktype = (value >> 1) & 7;
    left  = value & 0x10;
    right = value & 0x20;
}

void Combinator::WriteE0(unsigned char value)
{
    waveform = value & 7;
}

static const double PII = 3.141592653589793;

double Combinator::Produce(Operator &op, unsigned rate)
{
    register double value = 0.0;
    if(enabled)
    {
        value += op.Produce(waveform, hz, angle);
        angle += PII*2 / rate;
    }
    return value;
}
